// PDFFileRecognizer.cpp
//
// Recognise pdf files (EPOC R3)
//
// Copyright (c) 2000 Sander van der Wal
//
// $Id: Pdffilerecognizer.cpp 1.1 2000-03-27 14:38:13+02 svdwal Exp svdwal $
//
// $Log: Pdffilerecognizer.cpp $
// Revision 1.1  2000-03-27 14:38:13+02  svdwal
// Initial revision
//
// Revision 1.1  2000-02-14 14:17:04+01  svdwal
// - Initial checkin
//

#include "PerlFileRecognizer.h"

#include <e32svr.h>
#include <s32file.h>
#include <f32file.h>

#include <apaid.h>
#include <apacmdln.h>
#include <apgcli.h>


const TInt KPerlUidValue = 0x20030100;
const TUid KUidPerl={KPerlUidValue};

// Recognises PDF files - by examining the file's contents
CApaFileRecognizerType::TRecognizedType CPerlFileRecognizer::DoRecognizeFileL(RFs& aFs, TUidType /*aType*/)
{
  iRecognizedType=ENotRecognized;
  //Perl files are only recognized by by extension!
  TParsePtrC parse(*iFullFileName);
  if ( 0 == parse.Ext().CompareF( _L(".pl"))) {
    iRecognizedType=EDoc;
    iAppUid=KUidPerl;
    return iRecognizedType;
  }
  return iRecognizedType;
}

TThreadId CPerlFileRecognizer::RunL(TApaCommand aCommand,const TDesC* aDocFileName,const TDesC8* aTailEnd) const
{
  CApaCommandLine* commandLine=CApaCommandLine::NewLC();
  commandLine->SetCommandL(aCommand);
  if (iRecognizedType==EDoc) {
    TApaAppEntry appEntry;
 
	if (aDocFileName)
      commandLine->SetDocumentNameL(*iFullFileName);
  }
  else {
    User::Leave(KErrNotSupported);
  }
  if (aTailEnd)
    commandLine->SetTailEndL(*aTailEnd);
  TThreadId id=AppRunL(*commandLine);
  CleanupStack::PopAndDestroy(); // commandLine
  return id;
}

//
// DLL stuff...
//

// The gate function - ordinal 1
EXPORT_C CApaFileRecognizerType* CreateRecognizer()
{
  return new CPerlFileRecognizer();
}


// DLL entry point
GLDEF_C TInt E32Dll(TDllReason /*aReason*/)
{
	return KErrNone;
}

// MS VC++ 6.0 Learning edition version needs this to link
extern "C" void __pfnBkCheck() {}
